diff --git a/src/bbconfig.c b/src/bbconfig.c
index f461bd6..59483f6 100644
--- a/src/bbconfig.c
+++ b/src/bbconfig.c
@@ -356,11 +356,11 @@ static int bbconfig_parse_common(int opt, char *value) {
     case 'q'://quiet mode
       bb_status.verbosity = VERB_NONE;
       break;
-    case 'v'://increase verbosity level by one
+    /*case 'v'://increase verbosity level by one
       if (bb_status.verbosity < VERB_ALL) {
         bb_status.verbosity++;
       }
-      break;
+      break;*/
     case 'd'://X display number
       set_string_value(&bb_config.x_display, value);
       break;
@@ -387,7 +387,7 @@ static int bbconfig_parse_common(int opt, char *value) {
  * @param argv The arguments values
  * @param config_only 1 if the config file is the only option to be parsed
  */
-static void bbconfig_parse_opts(int argc, char *argv[], int config_only) {
+void bbconfig_parse_opts(int argc, char *argv[], int conf_round) {
   /* Parse the options, set flags as necessary */
   int opt;
   optind = 0;
@@ -397,17 +397,27 @@ static void bbconfig_parse_opts(int argc, char *argv[], int config_only) {
     if (opt == '?') {
       /* if an option was not recognized */
       print_usage(EXIT_FAILURE);
-    } if (opt == 'C') {
-      set_string_value(&bb_config.bb_conf_file, optarg);
-    } else if (!config_only) {
+    }
+    if (conf_round == P_FIRST) {
+        switch (opt) {
+            case 'C':
+                set_string_value(&bb_config.bb_conf_file, optarg);
+                break;
+            case 'v':
+                if (bb_status.verbosity < VERB_ALL) {
+                    bb_status.verbosity++;
+                }
+                break;
+            default:
+                break;
+        }
+    } else if (conf_round == P_SECOND) {
       /* try to find local options first, then try common options */
       if (bbconfig_parse_options(opt, optarg) ||
               bbconfig_parse_common(opt, optarg)) {
         /* option has been parsed, continue with the next options */
         continue;
       }
-      /* XXX is it possible to print the usage message earlier? */
-      print_usage(EXIT_FAILURE);
     }
   }
 }
@@ -417,7 +427,7 @@ static void bbconfig_parse_opts(int argc, char *argv[], int config_only) {
  *
  * @return 0 on success
  */
-static int bbconfig_parse_conf(void) {
+int bbconfig_parse_conf(void) {
     //Old behavior
     //return read_configuration();
 
@@ -499,6 +509,7 @@ static int bbconfig_parse_conf(void) {
     if (NULL != g_key_file_get_value(bbcfg, section, key, &err)) {
         bb_config.x_conf_file = g_key_file_get_string(bbcfg, section, key, &err);
     }
+    return 0;
 }
 
 /**
@@ -546,15 +557,17 @@ void init_config(int argc, char **argv) {
   bb_config.card_shutdown_state = bb_bool_from_string(CONF_TURNOFFATEXIT);
   set_string_value(&bb_config.pid_file, CONF_PID_FILE);
 
-  /* parse commandline configuration (for config file, if any) */
+/*
+  // parse commandline configuration (for config file, if any)
   bbconfig_parse_opts(argc, argv, 1);
 
-  /* parse config file */
+  //parse config file
   //read_configuration();
   bbconfig_parse_conf();
 
-  /* parse remaining command line options */
+  // parse remaining command line options
   bbconfig_parse_opts(argc, argv, 0);
+/**/
 }
 
 /**
diff --git a/src/bbconfig.h b/src/bbconfig.h
index c0dc8a1..a3a94da 100644
--- a/src/bbconfig.h
+++ b/src/bbconfig.h
@@ -30,6 +30,10 @@
 #define BB_DAEMON 1
 #define BB_NODEAMON 0
 
+// Parsing rounds
+#define P_FIRST 1
+#define P_SECOND 2
+
 /* common command line params */
 #define BBCONFIG_COMMON_OPTSTR "+qvd:s:l:C:hV"
 #define BBCONFIG_COMMON_LOPTS \
@@ -146,3 +150,7 @@ void set_string_value(char ** configstring, char * newvalue);
 struct option *config_get_longopts(struct option *longopts, size_t items);
 
 void print_usage(int exit_val);
+
+void bbconfig_parse_opts(int argc, char *argv[], int conf_round);
+
+int bbconfig_parse_conf(void);
diff --git a/src/bumblebeed.c b/src/bumblebeed.c
index 2b347ae..e84c9eb 100644
--- a/src/bumblebeed.c
+++ b/src/bumblebeed.c
@@ -358,7 +358,10 @@ int main(int argc, char* argv[]) {
     bb_log(LOG_ERR, "No nVidia graphics card found, quitting.\n");
     return (EXIT_FAILURE);
   }
+  bbconfig_parse_opts(argc, argv, P_FIRST);
   check_secondary();
+  bbconfig_parse_conf();
+  bbconfig_parse_opts(argc, argv, P_SECOND);
   /* dump the config after detecting the driver */
   config_dump();
   if (config_validate() != 0) {
diff --git a/src/optirun.c b/src/optirun.c
index f7c814a..eab4ad9 100644
--- a/src/optirun.c
+++ b/src/optirun.c
@@ -216,6 +216,9 @@ int main(int argc, char *argv[]) {
 
   /* Initializing configuration */
   init_config(argc, argv);
+  bbconfig_parse_opts(argc, argv, P_FIRST);
+  bbconfig_parse_conf();
+  bbconfig_parse_opts(argc,argv, P_SECOND);
   config_dump();
 
   bb_log(LOG_DEBUG, "%s version %s starting...\n", bb_status.program_name, GITVERSION);
